'use strict';Object.defineProperty(exports,"__esModule",{value:true});var _jsxFileName='src/Animate.jsx';var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source){if(Object.prototype.hasOwnProperty.call(source,key)){target[key]=source[key];}}}return target;};var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;if("value"in descriptor)descriptor.writable=true;Object.defineProperty(target,descriptor.key,descriptor);}}return function(Constructor,protoProps,staticProps){if(protoProps)defineProperties(Constructor.prototype,protoProps);if(staticProps)defineProperties(Constructor,staticProps);return Constructor;};}();var _react=require('react');var _react2=_interopRequireDefault(_react);var _propTypes=require('prop-types');var _propTypes2=_interopRequireDefault(_propTypes);var _reactDom=require('animated/lib/targets/react-dom');var _reactDom2=_interopRequireDefault(_reactDom);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}function _objectWithoutProperties(obj,keys){var target={};for(var i in obj){if(keys.indexOf(i)>=0)continue;if(!Object.prototype.hasOwnProperty.call(obj,i))continue;target[i]=obj[i];}return target;}function _defineProperty(obj,key,value){if(key in obj){Object.defineProperty(obj,key,{value:value,enumerable:true,configurable:true,writable:true});}else{obj[key]=value;}return obj;}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor)){throw new TypeError("Cannot call a class as a function");}}function _possibleConstructorReturn(self,call){if(!self){throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return call&&(typeof call==="object"||typeof call==="function")?call:self;}function _inherits(subClass,superClass){if(typeof superClass!=="function"&&superClass!==null){throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);}subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});if(superClass)Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass;}var UNIT_TRANSFORMS=['translateX','translateY','translateZ','transformPerspective'];var COLOR_PROPS=['backgroundColor','borderColor','borderBottomColor','borderLeftColor','borderRightColor','borderTopColor','color','fill','stroke'];var Animate=function(_Component){_inherits(Animate,_Component);function Animate(){var _ref;var _temp,_this,_ret;_classCallCheck(this,Animate);for(var _len=arguments.length,args=Array(_len),_key=0;_key<_len;_key++){args[_key]=arguments[_key];}return _ret=(_temp=(_this=_possibleConstructorReturn(this,(_ref=Animate.__proto__||Object.getPrototypeOf(Animate)).call.apply(_ref,[this].concat(args))),_this),_this.state={animatedStyles:_extends({},_this.props.style),isAnimating:false},_this.animatingKeys={},_this.colorDrivers={},_this.transformDrivers=[],_this.animate=function(key){return function(_ref2){var driver=_ref2.driver,toValue=_ref2.toValue;var AnimatedType=_reactDom2.default[_this.props.type];var listener=function listener(_ref3){var value=_ref3.value;if(value===toValue){delete _this.animatingKeys[key];driver.removeListener(id);if(Object.keys(_this.animatingKeys).length===0&&_this.state.isAnimating){_this.setState({isAnimating:false});}}};var id=driver.addListener(listener);AnimatedType(driver,_extends({},_this.props.config,{toValue:toValue})).start();};},_temp),_possibleConstructorReturn(_this,_ret);}_createClass(Animate,[{key:'componentWillReceiveProps',value:function componentWillReceiveProps(nextProps){if(JSON.stringify(this.props.style)!==JSON.stringify(nextProps.style)){this.setState({animatedStyles:this.createAnimatedStyles(nextProps),isAnimating:true});}}},{key:'componentDidUpdate',value:function componentDidUpdate(lastProps){this.animateStyles(lastProps);}},{key:'createAnimatedStyles',value:function createAnimatedStyles(nextProps){var _this2=this;var animatingKeys=[];return Object.keys(nextProps.style).reduce(function(acc,key){var animatedStyles=_extends({},acc);if(key==='transform'){var currTransform=_this2.props.style.transform;var nextTransform=nextProps.style.transform;_this2.transformDrivers=currTransform.map(function(prop,index){var currKey=Object.keys(prop)[0];var currValue=prop[currKey];return _defineProperty({},currKey,new _reactDom2.default.Value(parseFloat(currValue)));});animatedStyles.transform=_this2.transformDrivers.map(function(prop,index){var driverKey=Object.keys(prop)[0];var driverValue=prop[driverKey];var currProp=currTransform[index];var currKey=Object.keys(currProp)[0];var currValue=currProp[currKey];var nextProp=nextTransform[index];var nextKey=Object.keys(nextProp)[0];var nextValue=nextProp[nextKey];var minInput=Math.min(parseFloat(currValue),parseFloat(nextValue));var maxInput=Math.max(parseFloat(currValue),parseFloat(nextValue));var minOutput=minInput===parseFloat(currValue)?currValue:nextValue;var maxOutput=maxInput===parseFloat(currValue)?currValue:nextValue;if(UNIT_TRANSFORMS.indexOf(driverKey)>-1&&(!isNaN(minOutput)||!isNaN(maxOutput))){minOutput+='px';maxOutput+='px';}return _defineProperty({},driverKey,driverValue.interpolate({inputRange:[minInput,maxInput],outputRange:[minOutput,maxOutput]}));});}else if(COLOR_PROPS.indexOf(key)>-1){var currColor=_this2.props.style[key];var nextColor=nextProps.style[key];_this2.colorDrivers[key]=new _reactDom2.default.Value(0);animatedStyles[key]=_this2.colorDrivers[key].interpolate({inputRange:[0,1],outputRange:[currColor,nextColor]});}else{var currValue=_this2.props.style[key];var animatedValue=_this2.state.animatedStyles[key];animatedStyles[key]=animatedValue.constructor===_reactDom2.default.Value?animatedValue:new _reactDom2.default.Value(currValue);}_this2.animatingKeys[key]=true;return animatedStyles;},{});}},{key:'animateStyles',value:function animateStyles(lastProps){var _this3=this;var AnimatedType=_reactDom2.default[this.props.type];Object.keys(this.props.style).forEach(function(key){var runAnimation=_this3.animate(key);if(key==='transform'){var lastTransform=lastProps.style.transform;var currTransform=_this3.props.style.transform;_this3.transformDrivers.forEach(function(prop,index){var driverKey=Object.keys(prop)[0];var driverValue=prop[driverKey];var lastProp=lastTransform[index];var lastKey=Object.keys(lastProp)[0];var lastValue=lastProp[lastKey];var currProp=currTransform[index];var currKey=Object.keys(currProp)[0];var currValue=currProp[currKey];if(parseFloat(lastValue)!==parseFloat(currValue)){runAnimation({driver:driverValue,toValue:parseFloat(currValue)});}});}else if(COLOR_PROPS.indexOf(key)>-1){var lastColor=lastProps.style[key];var currColor=_this3.props.style[key];var colorDriver=_this3.colorDrivers[key];var delta=colorDriver._value>0?0:1;if(lastColor!==currColor){runAnimation({driver:colorDriver,toValue:colorDriver._value>0?0:1});}}else{var lastValue=lastProps.style[key];var currValue=_this3.props.style[key];var animatedValue=_this3.state.animatedStyles[key];if(lastValue!==currValue){runAnimation({driver:animatedValue,toValue:currValue});}}});}},{key:'render',value:function render(){var _props=this.props,children=_props.children,component=_props.component,type=_props.type,config=_props.config,style=_props.style,staticStyles=_props.staticStyles,props=_objectWithoutProperties(_props,['children','component','type','config','style','staticStyles']);var AnimatedComponent=_reactDom2.default.createAnimatedComponent(component);return _react2.default.createElement(AnimatedComponent,_extends({style:_extends({},staticStyles,this.state.animatedStyles),children:typeof children==='function'?children(this.state.isAnimating):children},props,{__source:{fileName:_jsxFileName,lineNumber:225}}));}}]);return Animate;}(_react.Component);Animate.propTypes={component:_propTypes2.default.any,config:_propTypes2.default.object,staticStyles:_propTypes2.default.object,type:_propTypes2.default.string};Animate.defaultProps={component:'div',config:{},type:'spring'};exports.default=Animate;