'use strict';Object.defineProperty(exports,"__esModule",{value:true});exports.EXITING=exports.ENTERED=exports.ENTERING=exports.EXITED=exports.UNMOUNTED=undefined;var _jsxFileName='src/Transition.js';var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;if("value"in descriptor)descriptor.writable=true;Object.defineProperty(target,descriptor.key,descriptor);}}return function(Constructor,protoProps,staticProps){if(protoProps)defineProperties(Constructor.prototype,protoProps);if(staticProps)defineProperties(Constructor,staticProps);return Constructor;};}();var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source){if(Object.prototype.hasOwnProperty.call(source,key)){target[key]=source[key];}}}return target;};var _reactDom=require('animated/lib/targets/react-dom');var _reactDom2=_interopRequireDefault(_reactDom);var _propTypes=require('prop-types');var _propTypes2=_interopRequireDefault(_propTypes);var _react=require('react');var _react2=_interopRequireDefault(_react);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}function _objectWithoutProperties(obj,keys){var target={};for(var i in obj){if(keys.indexOf(i)>=0)continue;if(!Object.prototype.hasOwnProperty.call(obj,i))continue;target[i]=obj[i];}return target;}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor)){throw new TypeError("Cannot call a class as a function");}}function _possibleConstructorReturn(self,call){if(!self){throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return call&&(typeof call==="object"||typeof call==="function")?call:self;}function _inherits(subClass,superClass){if(typeof superClass!=="function"&&superClass!==null){throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);}subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});if(superClass)Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass;}function _defineProperty(obj,key,value){if(key in obj){Object.defineProperty(obj,key,{value:value,enumerable:true,configurable:true,writable:true});}else{obj[key]=value;}return obj;}var UNMOUNTED=exports.UNMOUNTED='unmounted';var EXITED=exports.EXITED='exited';var ENTERING=exports.ENTERING='entering';var ENTERED=exports.ENTERED='entered';var EXITING=exports.EXITING='exiting';function rehydrateStyles(styles){}function buildAnimatedStyles(styles){return Object.keys(styles).reduce(function(acc,key){return _extends({},acc,_defineProperty({},key,new _reactDom2.default.Value(styles[key])));},{});}var Transition=function(_Component){_inherits(Transition,_Component);function Transition(props,context){_classCallCheck(this,Transition);var _this=_possibleConstructorReturn(this,(Transition.__proto__||Object.getPrototypeOf(Transition)).call(this,props,context));var parentGroup=context.transitionGroup;var appear=parentGroup&&!parentGroup.isMounting?props.enter:props.appear;var initialStatus=void 0;_this.nextStatus=null;if(props.in){if(appear){initialStatus=EXITED;_this.nextStatus=ENTERING;}else{initialStatus=ENTERED;}}else{if(props.lazy){initialStatus=UNMOUNTED;}else{initialStatus=EXITED;}}_this.state={status:initialStatus,driver:new _reactDom2.default.Value(0)};_this.nextCallback=null;return _this;}_createClass(Transition,[{key:'getChildContext',value:function getChildContext(){return{transitionGroup:null};}},{key:'componentDidMount',value:function componentDidMount(){this.updateStatus(true);}},{key:'componentWillReceiveProps',value:function componentWillReceiveProps(nextProps){var status=this.state.status;if(nextProps.in){if(status===UNMOUNTED){this.setState({status:EXITED});}if(status!==ENTERING&&status!==ENTERED){this.nextStatus=ENTERING;}}else{if(status===ENTERING||status===ENTERED){this.nextStatus=EXITING;}}}},{key:'componentDidUpdate',value:function componentDidUpdate(){this.updateStatus();}},{key:'updateStatus',value:function updateStatus(){var mounting=arguments.length>0&&arguments[0]!==undefined?arguments[0]:false;if(this.nextStatus!==null){if(this.nextStatus===ENTERING){this.performEnter(mounting);}else{this.performExit();}this.nextStatus=null;}else if(this.props.unmountOnExit&&this.state.status===EXITED){this.setState({status:UNMOUNTED});}}},{key:'performEnter',value:function performEnter(mounting){var _this2=this;var _props=this.props,appear=_props.appear,enter=_props.enter,exit=_props.exit;var appearing=this.context.transitionGroup?this.context.transitionGroup.isMounting:mounting;var styles={};if(!mounting&&!enter){this.setState({status:ENTERED});return;}Object.keys(enter).forEach(function(key){var enterStyle=enter[key];var initialStyle=appearing?appear[key]:exit[key];styles[key]=_this2.state.driver.interpolate({inputRange:[0,1],outputRange:[Math.min(enterStyle,initialStyle),Math.max(enterStyle,initialStyle)]});});this.state.driver.stopAnimation(function(){_this2.setState({status:ENTERING,styles:styles},function(){_reactDom2.default.spring(_this2.state.driver,{toValue:1}).start(function(_ref){var finished=_ref.finished;if(finished){_this2.setState({status:ENTERED});}});});});}},{key:'performExit',value:function performExit(){var _this3=this;var _props2=this.props,appear=_props2.appear,enter=_props2.enter,exit=_props2.exit;var styles={};if(!exit){this.setState({status:EXITED});return;}Object.keys(exit).forEach(function(key){var exitStyle=exit[key];var initialStyle=appear?appear[key]:enter[key];styles[key]=_this3.state.driver.interpolate({inputRange:[0,1],outputRange:[Math.min(exitStyle,initialStyle),Math.max(exitStyle,initialStyle)]});});this.state.driver.stopAnimation(function(){_this3.setState({status:EXITING,styles:styles},function(){_reactDom2.default.spring(_this3.state.driver,{toValue:0}).start(function(_ref2){var finished=_ref2.finished;if(finished){_this3.setState({status:EXITED},function(){_this3.props.onExited&&_this3.props.onExited();});}});});});}},{key:'render',value:function render(){var _props3=this.props,inProp=_props3.in,lazy=_props3.lazy,appear=_props3.appear,enter=_props3.enter,exit=_props3.exit,style=_props3.style,children=_props3.children,onEntered=_props3.onEntered,onExited=_props3.onExited,props=_objectWithoutProperties(_props3,['in','lazy','appear','enter','exit','style','children','onEntered','onExited']);var _state=this.state,status=_state.status,styles=_state.styles;if(status===UNMOUNTED){return null;}return _react2.default.createElement(_reactDom2.default.div,_extends({},props,{style:_extends({},style,styles),__source:{fileName:_jsxFileName,lineNumber:212}}),children);}}]);return Transition;}(_react.Component);Transition.contextTypes={transitionGroup:_propTypes2.default.object};Transition.childContextTypes={transitionGroup:function transitionGroup(){}};Transition.propTypes={in:_propTypes2.default.bool,lazy:_propTypes2.default.bool,appear:_propTypes2.default.object,enter:_propTypes2.default.object,exit:_propTypes2.default.object,onEnter:_propTypes2.default.func,onEntering:_propTypes2.default.func,onEntered:_propTypes2.default.func,onExit:_propTypes2.default.func,onExiting:_propTypes2.default.func,onExited:_propTypes2.default.func};function noop(){}Transition.defaultProps={in:false,lazy:false};exports.default=Transition;